use std::sync::{Arc, RwLock};
use std::thread;

const MAX_THREADS : usize = 200;

pub struct Guard {
    cont: Arc<RwLock<usize>>,
}

impl Guard {
    pub fn new() -> Self {
        Self{
            //threads: HashMap::new(),
            cont: Arc::new(RwLock::new(0)),
        }
    }

    pub fn can_add(&self) -> bool {
        *self.cont.read().unwrap() < MAX_THREADS
    }

    pub fn add_thread(&mut self,
        threads: (thread::JoinHandle<()>, thread::JoinHandle<()>))-> bool {
        if self.can_add() {
            //self.threads.insert(id, threads);
            *self.cont.write().unwrap() += 1;
            let cont: Arc<RwLock<usize>> = self.cont.clone();
            thread::spawn(move || {Self::whatch_client(cont, threads)});
            return true;
        } else {
            false
        }
    }

    fn whatch_client(cont: Arc<RwLock<usize>>,
        threads: (thread::JoinHandle<()>, thread::JoinHandle<()>)){
        threads.0.join();
        threads.1.join();
        *cont.write().unwrap() -= 1;
    }
}
