use std::net::{TcpListener, TcpStream};
use std::io::prelude::*;
use crate::conf;
use std::sync::{Arc, RwLock};

pub fn server_conf(conf: Arc<RwLock<conf::Config>>){
    let listener = TcpListener::bind(String::from("0.0.0.0:") +
                    conf.read().unwrap().get_port_conf()).unwrap();


    for stream in listener.incoming() {
        match stream{
        Ok(s) => process_reques(s),
        Err(_e) => println!("{}",_e),
        }
    }

}

fn process_reques(mut stream: TcpStream) {
    let mut buf: [u8; 256] = [1; 256];
    match stream.read(&mut buf){
        Ok(len) => check_state(&mut buf, len),
        Err(e) => println!("pos no {}", e),
    }
}

fn check_state(buf: &mut [u8; 256], len: usize) {
    let var = String::from_utf8(buf[0 .. len-2].to_vec()).unwrap();
    match var.as_str(){
        "some" => println!("entra"),
        _=> println!("pos no {}", var),
    }
}
