use std::thread;
use conf::server_conf;
use std::sync::{Arc, RwLock};

mod client;
mod conf;
mod protocol;
mod server_proxy;

fn main() {
    let servers = Arc::new(RwLock::new(conf::Config::new()));
    let s1 = servers.clone();
    let s2 = servers.clone();
    let stop1 = thread::spawn(|| server_proxy::start_proxy(s1));
    let stop2 = thread::spawn(|| conf::server_conf::server_conf(s2));
    stop1.join();
    stop2.join();
}
